/*****************************************************
Chip type           : ATtiny2313
Clock frequency     : 8,000000 MHz
*****************************************************/

#include <tiny2313.h> 
#include <delay.h>
#include <stdio.h>

//************************************************************
//   RC5
//************************************************************
unsigned char cnt_bit = 0;              //  
unsigned char code [14];                // 
unsigned char counter = 0;              //"" 

#define l_min    40                     //  "" (long)   ,  "" , 1,28..2,176 
#define l_max    68
#define s_min    22                     //  "" (short)   ,  "" , 0,704..1,088
#define s_max    34

bit state =  0;                                 //   
bit error = 0;                                  // 

//  ,  14                   
unsigned char toggle = 0;                       // ,      ,   -  .!
unsigned char address = 0;                      // , 5 
unsigned char command = 0;                      // (), 6     

void c_r_c(void){
 char i;
 for (i=0; i<14; i++) code[i]=0; 
} 

void c_tim(void){
 TCCR0A = 0x00;
 TCCR0B = 0x00;                   // 
 TCNT0 = 0x00;                   //    
 cnt_bit = 0;                    //   
}

// External Interrupt 0 service routine
interrupt [EXT_INT0] void ext_int0_isr(void)
        {
        counter = TCNT0;                        //  -
        TCNT0 = 0x00;                           // 
        error = 1;                              //  -    ,   
               
        if (cnt_bit == 0){                       //  
                TCCR0A = 0x00;  
                TCCR0B = 0x04;                           // ,  31250 (      )
                code [cnt_bit] = !PIND.2;               //  , PIND.2 -  ,  0
                cnt_bit++;                              //   
                state = 1;                              // , ..  1
                }else{                                        //   (   )
                
                        if ((counter>s_min) && (counter<s_max)){ //  
                                if (state){                     //  1
                                        state = 0;              // 
                                        error = 0;              // , ..  
                                        } else {                   //  0
                                                state = 1;                      // , ..  - 1
                                                code[cnt_bit] = !PIND.2;        //  -  
                                                cnt_bit++;                      //  
                                                error=0;                        // , ..  
                                        };
                                };     
                   
                        if ((counter>l_min) && (counter<l_max)){ //  
                                code[cnt_bit] = !PIND.2;        //  -  
                                cnt_bit++;                      //  
                                error = 0;                      // , ..  
                                };
                                                  
                        if (error == 1){                         //       ,  
                                c_tim();
                                counter = 0;                    // 
                                c_r_c();                         //   
                                };
                   
                        if (cnt_bit == 14){                      //   14 
                                c_tim();
                                toggle = code[2];               //-
                                                                //    
                                address = (code[3] << 4)|(code[4] << 3)|(code[5] << 2)|(code[6] << 1)|code[7];                    
                                command = (code[8] << 5)|(code[9] << 4)|(code[10] << 3 )|(code[11] << 2)|(code[12] << 1)|code[13];     
                                c_r_c();   //   
                                };
                        };                                                                                
        }

// Timer 0 overflow interrupt service routine
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
        {
        c_tim();
        counter = 0;                    // 
        c_r_c();
        }
//************************************************************


void main(void)
{

// Port B initialization
PORTB=0x00;
DDRB=0x4D;

// Port D initialization
PORTD=0x04;
DDRD=0x00;

// Timer/Counter 0 initialization
TCCR0A=0x00;
TCCR0B=0x00;
TCNT0=0x00;
OCR0A=0x00;
OCR0B=0x00;

// External Interrupt(s) initialization
// INT0: On
// INT0 Mode: Any change
// INT1: Off
GIMSK=0x40;
MCUCR=0x02;
EIFR=0x40;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x02;

UCSRA=0x00;
UCSRB=0x08;
UCSRC=0x06;
UBRRH=0x00;
UBRRL=0x33;

        #asm ("sei")

         printf("Power_OK \n\r");    
         
while (1)
        { 
        printf("Address: %u             ", address);
        printf("Comand: %u", command);    
        printf("\n\r"); 
   }
}